<?php

namespace Jeff;

use ManiaControl\Callbacks\CallbackListener;
use ManiaControl\Callbacks\CallbackManager;
use ManiaControl\Callbacks\Callbacks;
use ManiaControl\Callbacks\Structures\ManiaPlanet\StartEndStructure;
use ManiaControl\Callbacks\Structures\ShootMania\OnEliteEndTurnStructure;
use ManiaControl\Callbacks\Structures\ShootMania\OnEliteStartTurnStructure;
use ManiaControl\Commands\CommandListener;
use ManiaControl\Commands\CommandManager;
use FML\Controls\Control;
use FML\Controls\Labels\Label_Text;
use FML\Controls\Quad;
use FML\ManiaLink;
use ManiaControl\ManiaControl;
use FML\Controls\Audio;
use ManiaControl\Players\Player;
use ManiaControl\Players\PlayerManager;
use ManiaControl\Manialinks\ManialinkPageAnswerListener;
use ManiaControl\Admin\AuthenticationManager;
use ManiaControl\Plugins\Plugin;
use ManiaControl\Settings\SettingManager;
use ManiaControl\Callbacks\TimerListener;
use ManiaControl\Callbacks\TimerManager;
use ManiaControl\Settings\Setting;




/**
 * ManiaControl Sound Plugin
 *
 * @author Jeff
 * THANKS TO SEN-SAI who allows me to copy a part of his Plugin. This one is more his plugin than mine.
 * THANKS TO SEN-SAI, THIS PLUGIN IS LIKE HIS PLUGIN  EXCEPT SOUNDS REQUESTS...
 * i'll add other adjustements step by step !
 *
 */

class XpSoundsElite implements CommandListener, CallbackListener, ManialinkPageAnswerListener, TimerListener,  Plugin {
	/**
	 * Constants
	 */
	const PLUGIN_ID              = 149;
	const PLUGIN_VERSION         = 0.78;
	const PLUGIN_NAME            = 'XpSoundsElite';
	const PLUGIN_AUTHOR          = 'Jeff';
	const DATE                   = 'd-m-y h:i:sa T';
	const MLID_SOUNDS            = 'XpSoundsPlugin.MLID';
	const MLID_MESSAGEWIDGET	 = 'XpSoundsPlugin.MessageWidget';
	const SHOWN_MAIN_WINDOW      = -1;
	
	
	/**
	 * Private properties
	 */
	/** @var maniaControl $maniaControl */
	private $maniaControl = null;
	private $command = array();
	private $warmup = false;
	private $messageShow = false;
	private $pluginPath = "";
	private $rson = "";
	private $sounds = array();
	private $turnTime = 0;
	private $timer = false;

	/**
	 * Prepares the Plugin
	 *
	 * @param ManiaControl $maniaControl
	 * @return mixed
	 */
	public static function prepare(ManiaControl $maniaControl) {

		$GLOBALS['death']=false;
		$GLOBALS['page']=1;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::load()
	 */
	public function load(ManiaControl $maniaControl) {

		$this->maniaControl = $maniaControl;
		$this->pluginPath =  "http://jcosse.free.fr/sounds/";
		


		// Settings
		
		//$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_CUSTOM, false);
		//$this->maniaControl->getSettingManager()->initSetting($this, self::SETTING_SOUND_USR, '');


		// new callbacks
	
		$this->maniaControl->getCallbackManager()->registerCallbackListener(PlayerManager::CB_PLAYERCONNECT, $this, 'preloadSoundstoLogin');
		$this->maniaControl->getCallbackManager()->registerCallbackListener(PlayerManager::CB_PLAYERDISCONNECT, $this, 'playerDisconnect');

		$this->maniaControl->getCommandManager()->registerCommandListener('sbiere', $this, 'biere');
		$this->maniaControl->getCommandManager()->registerCommandListener('segl', $this, 'egl');
		$this->maniaControl->getCommandManager()->registerCommandListener('sfachir', $this, 'fachir');
		$this->maniaControl->getCommandManager()->registerCommandListener('sfil', $this, 'fil');
		$this->maniaControl->getCommandManager()->registerCommandListener('sgglisse', $this, 'gglisse');
		$this->maniaControl->getCommandManager()->registerCommandListener('sglad', $this, 'glad');
		$this->maniaControl->getCommandManager()->registerCommandListener('sgroupir', $this, 'groupir');
		$this->maniaControl->getCommandManager()->registerCommandListener('sbat', $this, 'bat');
		$this->maniaControl->getCommandManager()->registerCommandListener('slaclef', $this, 'laclef');
		$this->maniaControl->getCommandManager()->registerCommandListener('slapin', $this, 'lapin');
		$this->maniaControl->getCommandManager()->registerCommandListener('smalin', $this, 'malin');
		$this->maniaControl->getCommandManager()->registerCommandListener('smusic', $this, 'music');
		$this->maniaControl->getCommandManager()->registerCommandListener('spont', $this, 'pont');
		$this->maniaControl->getCommandManager()->registerCommandListener('ssouris', $this, 'souris');
		$this->maniaControl->getCommandManager()->registerCommandListener('stenaille', $this, 'tenaille');
		$this->maniaControl->getCommandManager()->registerCommandListener('sconsp', $this, 'consp');
		$this->maniaControl->getCommandManager()->registerCommandListener('spun', $this, 'pun');
		$this->maniaControl->getCommandManager()->registerCommandListener('svenin', $this, 'venin');
		$this->maniaControl->getCommandManager()->registerCommandListener('szen', $this, 'zen');
		$this->maniaControl->getCommandManager()->registerCommandListener('sbagar', $this, 'bagar');
		$this->maniaControl->getCommandManager()->registerCommandListener('sboi', $this, 'boi');
		$this->maniaControl->getCommandManager()->registerCommandListener('sdefonc', $this, 'defonc');
		$this->maniaControl->getCommandManager()->registerCommandListener('sgentil', $this, 'gentil');
		$this->maniaControl->getCommandManager()->registerCommandListener('smassue', $this, 'massue');
		$this->maniaControl->getCommandManager()->registerCommandListener('sfos', $this, 'fos');
		$this->maniaControl->getCommandManager()->registerCommandListener('sforce', $this, 'force');
		$this->maniaControl->getCommandManager()->registerCommandListener('spo', $this, 'po');
		$this->maniaControl->getCommandManager()->registerCommandListener('smoi', $this, 'moi');
		
		$this->maniaControl->getCallbackManager()->registerCallbackListener(CallbackManager::CB_MP_PLAYERCHAT, $this, 'handleChatCallback');

		$this->maniaControl->getCallbackManager()->registerCallbackListener(SettingManager::CB_SETTING_CHANGED, $this, 'handleSettingChangedCallback');

		

		return true;
	}

	public function registerCommand( $id, $command ) {
		$this->command[$id] = $command;
	}

	public function unRegisterCommand( $id ) {
		if( isset( $this->command[$id] ) ) {
			unset( $this->command[$id]);
		}
	}

	


	/**
	 * @see \ManiaControl\Plugins\Plugin::unload()
	 */
	public function unload() {
	}

	/**
	 * Handle Setting Changed Callback
	 *
	 * @param Setting $setting
	 */

	public function handleChatCallback( array $chat ) {
		$command = explode(' ', $chat[1][2]);
		$trigger = ltrim(strtolower($command[0]), '/');

		$login  = $chat[1][1];
		$player = $this->maniaControl->getPlayerManager()->getPlayer($login);
		if (!$player) {
			return;
		}

		if( isset( $this->command[$trigger] ) ){
			$key = $this->command[$trigger];
			$snd = $this->sounds[$key];
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : ' . $snd['name'];
			$this->maniaControl->getChat()->sendChat($msg, null, false);
			$this->playSound($snd['trigger']);
			} 
			/*else {
			$msg = 'No such sound command :' . $trigger;
			$this->maniaControl->getChat()->sendChat($msg, $player->login, false);
		}*/
	}

	public function loadPlayers() {
		$players = $this->maniaControl->getPlayerManager()->getPlayers();
		foreach ($players as $player)
		{
			$this->kills[$player->login]=0;
		}
	}


	public function playerDisconnect(player $player) {
	}

	public function preloadSoundstoLogin(player $player) {
		$this->kills[$player->login]=0;
		$manialink = new ManiaLink(self::MLID_SOUNDS);
		foreach ($this->sounds as $sound)
		{
			$vox = new Audio();
			$vox->setData($this->pluginPath . $sound['file']);
			$vox->setPlay("1");
			$vox->setLooping("0");
			$vox->setVolume(0);
			$vox->setVisible(false);
			$manialink->add($vox);
		}


		$this->maniaControl->getManialinkManager()->sendManialink($manialink,$player);
	}

	public function preloadSounds() {
		$manialink = new ManiaLink(self::MLID_SOUNDS);
		$this->maniaControl->getChat()->sendChat('$fffPreloading sounds..', null, false);
		foreach ($this->sounds as $sound)
		{
			$vox = new Audio();
			$vox->setData($this->pluginPath . $sound['file']);
			$vox->setPlay("1");
			$vox->setLooping("0");
			$vox->setVolume(0);
			$vox->setVisible(false);
			$manialink->add($vox);
		}

		$this->maniaControl->getManialinkManager()->sendManialink($manialink);
	}

	public function playSound($trigger,$vol=false,$player=false)
	{
		if(!$vol) $vol=1;
		foreach ($this->sounds as $sound)
		{
			if (strtolower($sound['trigger'])==strtolower($trigger))
			{
				$manialink = new ManiaLink(self::MLID_SOUNDS);
				$vox = new Audio();
				if ( $trigger == "moi" ){
					$vox->setData($this->pluginPath.$GLOBALS['rson'].'/'.$sound['file']);
				} else {
					$vox->setData($this->pluginPath . $sound['file']);
				}				
				$vox->setPlay("1");
				$vox->setLooping("0");
				$vox->setVolume($vol);
				$vox->setVisible(false);
				$manialink->add($vox);
				if(!$player)
				{
					$this->maniaControl->getManialinkManager()->sendManialink($manialink,null,(int)$sound['duration'],false);
				}
				else
				{
					$this->maniaControl->getManialinkManager()->sendManialink($manialink,$player,(int)$sound['duration']);
				}
				return;
			}
		}
	}


	public function getScriptSettings() {
		$settings = $this->maniaControl->getClient()->getModeScriptSettings();
		$tLimit = $settings['S_TimeLimit'];
		$tPole = $settings['S_TimePole'];
		$this->turnTime = $tLimit - 10 + $tPole ;
	}


	private function getTarget($login) {
		$player = null;
		foreach ($this->maniaControl->getPlayerManager()
		                            ->getPlayers() as $player) {
			if ($login == $player || $login == $player->login || $login == $player->pid || $login == $player->nickname) {
				return $player->nickname;
			}
		}

		if ($player && strtolower($login) === 'lj') {
			return $player->nickname;
		}

		//returns the text given if nothing matches
		return $login;
	}
	
		
	public function checkMute(Player $player) {
		if( $player->isMuted() ) {
			$this->maniaControl->getChat()->sendError("You can't use this command because you are muted!", $player);
			return true;
		} else return false;
	}

/*  AUTH_LEVEL_ADMIN  */


	public function moi (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_ADMIN)) {
			return;
		}
		$command = explode(" ", $chat[1][2]);
		if (!isset($command[1])) return ;
		 ;
		$GLOBALS['rson'] = ltrim(strtolower($command[1]), " ");
			if( $GLOBALS['rson'] == '') {
			return ;
			} else {
								
				$this->sounds[27]['trigger'] = 'moi';
				$this->sounds[27]['file'] = "moi.ogg";
				$this->sounds[27]['duration'] = 10000;
				$trigger="moi";	
			}
				
				//$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  !';
				//$this->sendToAdmins($msg);
				$this->playSound($trigger);
			
	}	

	public function biere (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_ADMIN)) {
			return;
		}
		$command = explode(" ", $chat[1][2]);
		$this->sounds[0]['trigger'] = 'biere';
		$this->sounds[0]['file'] = "biere.ogg";
		$this->sounds[0]['duration'] = 1200;
		$trigger="biere";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Ma Biere $z$<' . $this->getTarget($command[1]) . '$>$i! ';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Ma Biere !';
		}
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	
	public function bagar (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_ADMIN)) {
			return;
		}
		$command = explode(" ", $chat[1][2]);
		$this->sounds[19]['trigger'] = 'bagar';
		$this->sounds[19]['file'] = "bagar.ogg";
		$this->sounds[19]['duration'] = 9000;
		$trigger="bagar";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  tu veux te battre $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : tu veux te battre';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : tu veux te battre';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function boi (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_ADMIN)) {
			return;
		}
		$command = explode(" ", $chat[1][2]);
		$this->sounds[20]['trigger'] = 'boi';
		$this->sounds[20]['file'] = "boi.ogg";
		$this->sounds[20]['duration'] = 5700;
		$trigger="boi";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  whiskey cocacola $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : whiskey cocacola';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : whiskey cocacola';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function fos (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_ADMIN)) {
			return;
		}
		$command = explode(" ", $chat[1][2]);
		$this->sounds[24]['trigger'] = 'fos';
		$this->sounds[24]['file'] = "fos.ogg";
		$this->sounds[24]['duration'] = 3700;
		$trigger="fos";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : with all...fo  $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : with all...fo';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : with all...fo';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}	
	
	
	
/*  AUTH_LEVEL_MODERATOR  */

	
	public function malin (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_MODERATOR)) {
			return;
		}
		$command = explode(" ", $chat[1][2]);
		$this->sounds[10]['trigger'] = 'malin';
		$this->sounds[10]['file'] = "malin.ogg";
		$this->sounds[10]['duration'] = 5800;
		$trigger="malin";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  c est malin ! $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : c est malin !';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : c est malin !';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function pun (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_MODERATOR)) {
			return;
		}
		$command = explode(" ", $chat[1][2]);
		$this->sounds[16]['trigger'] = 'pun';
		$this->sounds[16]['file'] = "pun.ogg";
		$this->sounds[16]['duration'] = 3500;
		$trigger="pun";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  vous me copierez 100 fois $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : vous me copierez 100 fois';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : vous me copierez 100 fois';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}	
	
	public function gentil (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_MODERATOR)) {
			return;
		}
		$command = explode(" ", $chat[1][2]);
		$this->sounds[22]['trigger'] = 'gentil';
		$this->sounds[22]['file'] = "gentil.ogg";
		$this->sounds[22]['duration'] = 5000;
		$trigger="gentil";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : you are nice but go there  $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : you are nice but go there';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : you are nice but go there';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	
	
	
/*  AUTH_LEVEL_ALL */
	
	public function fachir (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		/*if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_MODERATOR)) {
			return;
		}*/
		$this->sounds[2]['trigger'] = 'fachir';
		$this->sounds[2]['file'] = "fachir.ogg";
		$this->sounds[2]['duration'] = 3000;
		$trigger="fachir";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : je vais me fachir';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function egl (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[1]['trigger'] = 'egl';
		$this->sounds[1]['file'] = "eg1.ogg";
		$this->sounds[1]['duration'] = 4000;
		$trigger="egl";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Eglantine';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}

	public function sendToAdmins($txt) {
		$this->maniaControl->getChat()->sendInformationToAdmins($txt);

	}

	

	public function fil (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[3]['trigger'] = 'fil';
		$this->sounds[3]['file'] = "fil.ogg";
		$this->sounds[3]['duration'] = 4700;
		$trigger="fil";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : le fil vert sur le bouton vert';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}

	public function gglisse (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[4]['trigger'] = 'gglisse';
		$this->sounds[4]['file'] = "gglisse.ogg";
		$this->sounds[4]['duration'] = 5400;
		$trigger="gglisse";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : j ai glissé chef';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}

	public function glad (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$command = explode(" ", $chat[1][2]);
		$this->sounds[5]['trigger'] = 'glad';
		$this->sounds[5]['file'] = "glad.ogg";
		$this->sounds[5]['duration'] = 7000;
		$trigger="glad";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Ma Biere $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : i am very glad';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : i am very glad';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}
	
	public function groupir (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$command = explode(" ", $chat[1][2]);
		$this->sounds[6]['trigger'] = 'groupir';
		$this->sounds[6]['file'] = "groupir.ogg";
		$this->sounds[6]['duration'] = 5400;
		$trigger="groupir";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  Restez groupirr! $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Restez groupirr!';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Restez groupirr!';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}
	public function bat (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		/*if (!$this->maniaControl->getAuthenticationManager()->checkRight($player, AuthenticationManager::AUTH_LEVEL_MODERATOR)) {
			return;
		}*/
		$this->sounds[7]['trigger'] = 'bat';
		$this->sounds[7]['file'] = "isbat.ogg";
		$this->sounds[7]['duration'] = 2000;
		$trigger="bat";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : yen a qui se battent !';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function laclef (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[8]['trigger'] = 'laclef';
		$this->sounds[8]['file'] = "laclef.ogg";
		$this->sounds[8]['duration'] = 8000;
		$trigger="laclef";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : gib mir ein schtroomfschlusseuh!';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function lapin (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[9]['trigger'] = 'lapin';
		$this->sounds[9]['file'] = "lapin.ogg";
		$this->sounds[9]['duration'] = 4300;
		$trigger="lapin";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Un lapin chef ';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}

	public function music (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[11]['trigger'] = 'music';
		$this->sounds[11]['file'] = "music.ogg";
		$this->sounds[11]['duration'] = 3500;
		$trigger="music";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : la 7ème!';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}
	public function pont (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[12]['trigger'] = 'pont';
		$this->sounds[12]['file'] = "pont.ogg";
		$this->sounds[12]['duration'] = 4300;
		$trigger="pont";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : si je connaissais le gars';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function souris (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$command = explode(" ", $chat[1][2]);
		$this->sounds[13]['trigger'] = 'souris';
		$this->sounds[13]['file'] = "souris.ogg";
		$this->sounds[13]['duration'] = 4000;
		$trigger="souris";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  souris, on gagne la guerre $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : souris, on gagne la guerre';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : souris, on gagne la guerre';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function tenaille (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[14]['trigger'] = 'tenaille';
		$this->sounds[14]['file'] = "tenaille.ogg";
		$this->sounds[14]['duration'] = 3700;
		$trigger="tenaille";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : la tenaille!';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function consp (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[15]['trigger'] = 'consp';
		$this->sounds[15]['file'] = "consp.ogg";
		$this->sounds[15]['duration'] = 3000;
		$trigger="consp";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Das ist ein conspiration!';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}

	public function venin (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$this->sounds[17]['trigger'] = 'venin';
		$this->sounds[17]['file'] = "venin.ogg";
		$this->sounds[17]['duration'] = 3300;
		$trigger="venin";
		$msg = '$g[$<' . $player->nickname . '$>$s] is playing : venin';
		$this->sendToAdmins($msg);
		$this->playSound($trigger);
	}
	public function zen (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$command = explode(" ", $chat[1][2]);
		$this->sounds[18]['trigger'] = 'zen';
		$this->sounds[18]['file'] = "zen.ogg";
		$this->sounds[18]['duration'] = 4000;
		$trigger="zen";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  zeeennn $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : zeeennn';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : zeeennn';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}


	public function defonc (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$command = explode(" ", $chat[1][2]);
		$this->sounds[21]['trigger'] = 'defonc';
		$this->sounds[21]['file'] = "defonc.ogg";
		$this->sounds[21]['duration'] = 4000;
		$trigger="defonc";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing :  Comme il t a defonce $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Comme il t a defonce';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Comme il t a defonce';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}

	public function massue (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$command = explode(" ", $chat[1][2]);
		$this->sounds[23]['trigger'] = 'massue';
		$this->sounds[23]['file'] = "massue.ogg";
		$this->sounds[23]['duration'] = 6200;
		$trigger="massue";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : angry, just loose  $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : angry, just loose';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : angry, just loose';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}
	public function force (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$command = explode(" ", $chat[1][2]);
		$this->sounds[26]['trigger'] = 'force';
		$this->sounds[26]['file'] = "force.ogg";
		$this->sounds[26]['duration'] = 2500;
		$trigger="force";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Que la force soit avec toi  $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Que la force soit avec toi ';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : Que la force soit avec toi ';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}	
	public function po (array $chat, Player $player) {
		if ($this->checkMute($player) ) return;
		$command = explode(" ", $chat[1][2]);
		$this->sounds[25]['trigger'] = 'po';
		$this->sounds[25]['file'] = "po.ogg";
		$this->sounds[25]['duration'] = 6500;
		$trigger="po";
		if (isset($command[1])) {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : the force will be with you  $z$<' . $this->getTarget($command[1]) . '$>$i!';
		} else {
			$msg = '$g[$<' . $player->nickname . '$>$s] is playing : the force will be with you ';
		}
		//$msg = '$g[$<' . $player->nickname . '$>$s] is playing : the force will be with you ';
		//$this->sendToAdmins($msg);
		$this->maniaControl->getChat()
		                   ->sendChat($msg, null, false);
		$this->playSound($trigger);
	}	
	/**
	 * @see \ManiaControl\Plugins\Plugin::getId()
	 */
	public static function getId() {
		return self::PLUGIN_ID;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getName()
	 */
	public static function getName() {
		return self::PLUGIN_NAME;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getVersion()
	 */
	public static function getVersion() {
		return self::PLUGIN_VERSION;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getAuthor()
	 */
	public static function getAuthor() {
		return self::PLUGIN_AUTHOR;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getDescription()
	 */
	public static function getDescription() {
		return 'Core extender plugin for sound control.';
	}


}
